unit grShare;

interface

uses Kol,Share,Win,KOLGRushControls,Windows;

const
  HAlign : array[0..2] of TGRushHAlign        =(haLeft,haRight,haCenter);
  VAlign : array[0..2] of TGRushVAlign        =(vaCenter,vaTop,vaBottom);
  GStyle : array[0..6] of TGRushGradientStyle =(gsSolid,gsVertical,gsHorizontal,gsDoubleVert,gsDoubleHorz,gsFromTopLeft,gsFromTopRight);
  Speed  : array[0..5] of TGRushSpeed         =(usImmediately,usVeryFast,usFast,usNormal,usSlow,usVerySlow);

{$I share.inc}

type GRush = class(THIWin)
   protected
     rCaption:string;  
//    GData:PData;
//_Data:TData;
   private
 //   Bmp:PBitmap;
     procedure SetCaption (const Value:string);
//     procedure SetPicture(Value:HBITMAP);

   public
     _prop_Color:integer;
// All
     _prop_DrawFocusRect:       boolean;
     _prop_AntiAliasing:        boolean;
     _prop_hAlignment:          byte;
     _prop_vAlignment:          byte;
     _prop_UpdateSpeed:         byte;
     _prop_CheckMetric:         integer;
     _prop_ColorCheck:          integer;

     _prop_GlyphWidth:          integer;
     _prop_GlyphHeight:         integer;
//     _prop_GlyphBitmap:         PBitmap;  //
     _prop_Spacing:             integer;
     _prop_GlyphAttached:       boolean;

     _prop_Kind:                boolean;
     _prop_Rect:                boolean;
     _prop_DrawProgress:        boolean;
// Def //
     _prop_ColorFrom:           integer;
     _prop_ColorTo:             integer;
     _prop_GradientStyle:       byte;
     _prop_ColorText:           integer;
     _prop_ColorShadow:         integer;
     _prop_ShadowOffset:        integer;
     _prop_BorderWidth:         integer;
     _prop_BorderColor:         integer;
     _prop_BorderRoundWidth:    integer;
     _prop_BorderRoundHeight:   integer;
// Over // ov
     _prop_ovColorFrom:         integer;
     _prop_ovColorTo:           integer;
     _prop_ovGradientStyle:     byte;
     _prop_ovColorText:         integer;
     _prop_ovColorShadow:       integer;
     _prop_ovShadowOffset:      integer;
     _prop_ovBorderWidth:       integer;
     _prop_ovBorderColor:       integer;
     _prop_ovBorderRoundWidth:  integer;
     _prop_ovBorderRoundHeight: integer;
// Down // ps
     _prop_psColorFrom:         integer;
     _prop_psColorTo:           integer;
     _prop_psGradientStyle:     byte;
     _prop_psColorText:         integer;
     _prop_psColorShadow:       integer;
     _prop_psShadowOffset:      integer;
     _prop_psBorderWidth:       integer;
     _prop_psBorderColor:       integer;
     _prop_psBorderRoundWidth:  integer;
     _prop_psBorderRoundHeight: integer;
// Dis // ds
     _prop_dsColorFrom:         integer;
     _prop_dsColorTo:           integer;
     _prop_dsGradientStyle:     byte;
     _prop_dsColorText:         integer;
     _prop_dsColorShadow:       integer;
     _prop_dsShadowOffset:      integer;
     _prop_dsBorderWidth:       integer;
     _prop_dsBorderColor:       integer;
     _prop_dsBorderRoundWidth:  integer;
     _prop_dsBorderRoundHeight: integer;

     procedure Init;override;
     procedure _work_doCaption (var _Data:TData; Index:word);
     property _prop_Caption:string read rCaption write SetCaption;

     procedure _work_doLoadGVars            (var _Data:TData; Index:word);
// All
     procedure _work_doDrawFocusRect        (var _Data:TData; Index:word);
     procedure _work_doAntiAliasing         (var _Data:TData; Index:word);
     procedure _work_dohAlignment           (var _Data:TData; Index:word);
     procedure _work_dovAlignment           (var _Data:TData; Index:word);
     procedure _work_doUpdateSpeed          (var _Data:TData; Index:word);

     procedure _work_doCheckMetric          (var _Data:TData; Index:word);
     procedure _work_doColorCheck           (var _Data:TData; Index:word);
     procedure _work_doSpacing              (var _Data:TData; Index:word);

     procedure _work_doKind                 (var _Data:TData; Index:word);
     procedure _work_doRect                 (var _Data:TData; Index:word);
     procedure _work_doDrawProgress         (var _Data:TData; Index:word);
// Color // All
     procedure _work_doColor                (var _Data:TData; Index:word);
// Def //
     procedure _work_doColorFrom            (var _Data:TData; Index:word);
     procedure _work_doColorTo              (var _Data:TData; Index:word);
     procedure _work_doGradientStyle        (var _Data:TData; Index:word);
     procedure _work_doColorText            (var _Data:TData; Index:word);
     procedure _work_doColorShadow          (var _Data:TData; Index:word);
     procedure _work_doShadowOffset         (var _Data:TData; Index:word);
     procedure _work_doBorderWidth          (var _Data:TData; Index:word);
     procedure _work_doBorderColor          (var _Data:TData; Index:word);
     procedure _work_doBorderRoundWidth     (var _Data:TData; Index:word);
     procedure _work_doBorderRoundHeight    (var _Data:TData; Index:word);
// Over // ov
     procedure _work_doovColorFrom          (var _Data:TData; Index:word);
     procedure _work_doovColorTo            (var _Data:TData; Index:word);
     procedure _work_doovGradientStyle      (var _Data:TData; Index:word);
     procedure _work_doovColorText          (var _Data:TData; Index:word);
     procedure _work_doovColorShadow        (var _Data:TData; Index:word);
     procedure _work_doovShadowOffset       (var _Data:TData; Index:word);
     procedure _work_doovBorderWidth        (var _Data:TData; Index:word);
     procedure _work_doovBorderColor        (var _Data:TData; Index:word);
     procedure _work_doovBorderRoundWidth   (var _Data:TData; Index:word);
     procedure _work_doovBorderRoundHeight  (var _Data:TData; Index:word);
// Down // ps
     procedure _work_dopsColorFrom          (var _Data:TData; Index:word);
     procedure _work_dopsColorTo            (var _Data:TData; Index:word);
     procedure _work_dopsGradientStyle      (var _Data:TData; Index:word);
     procedure _work_dopsColorText          (var _Data:TData; Index:word);
     procedure _work_dopsColorShadow        (var _Data:TData; Index:word);
     procedure _work_dopsShadowOffset       (var _Data:TData; Index:word);
     procedure _work_dopsBorderWidth        (var _Data:TData; Index:word);
     procedure _work_dopsBorderColor        (var _Data:TData; Index:word);
     procedure _work_dopsBorderRoundWidth   (var _Data:TData; Index:word);
     procedure _work_dopsBorderRoundHeight  (var _Data:TData; Index:word);
// Dis // ds
     procedure _work_dodsColorFrom          (var _Data:TData; Index:word);
     procedure _work_dodsColorTo            (var _Data:TData; Index:word);
     procedure _work_dodsGradientStyle      (var _Data:TData; Index:word);
     procedure _work_dodsColorText          (var _Data:TData; Index:word);
     procedure _work_dodsColorShadow        (var _Data:TData; Index:word);
     procedure _work_dodsShadowOffset       (var _Data:TData; Index:word);
     procedure _work_dodsBorderWidth        (var _Data:TData; Index:word);
     procedure _work_dodsBorderColor        (var _Data:TData; Index:word);
     procedure _work_dodsBorderRoundWidth   (var _Data:TData; Index:word);
     procedure _work_dodsBorderRoundHeight  (var _Data:TData; Index:word);

//     property _prop_GlyphBitmap:HBITMAP write SetPicture;
   end;

implementation

uses hiGlobalVar;

procedure GRush.Init;
begin
  inherited;
  {$ifdef F_P}
  with PGRushControl(Control) do
  {$else}
  with PGRushControl(Control)^ do
  {$endif}
   begin
// All
    All_DrawFocusRect      :=  _prop_DrawFocusRect;
    All_AntiAliasing       :=  _prop_AntiAliasing;
    All_TextHAlign         :=  HAlign[_prop_hAlignment];
    All_TextVAlign         :=  VAlign[_prop_vAlignment];
    All_UpdateSpeed        :=  Speed[_prop_UpdateSpeed];

    All_CheckMetric        :=  _prop_CheckMetric;
    All_ColorCheck         :=  _prop_ColorCheck;

    All_GlyphWidth         :=  _prop_GlyphWidth;
    All_GlyphHeight        :=  _prop_GlyphHeight;
//    All_GlyphBitmap        :=  _prop_GlyphBitmap;    
    All_Spacing            :=  _prop_Spacing;   
    All_GlyphAttached      :=  _prop_GlyphAttached;   



    
    All_DrawProgress       := _prop_DrawProgress;
    All_DrawProgressRect   := _prop_Rect;
    All_ProgressVertical   := _prop_Kind; 
// Def //
    Def_ColorOuter         :=  _prop_Color;
    Def_ColorFrom          :=  _prop_ColorFrom;
    Def_ColorTo            :=  _prop_ColorTo;
    Def_GradientStyle      :=  GStyle[_prop_GradientStyle];
    Def_ColorText          :=  _prop_ColorText;
    Def_ColorShadow        :=  _prop_ColorShadow;
    Def_ShadowOffset       :=  _prop_ShadowOffset;
    Def_BorderWidth        :=  _prop_BorderWidth; 
    Def_BorderColor        :=  _prop_BorderColor;
    Def_BorderRoundWidth   :=  _prop_BorderRoundWidth;
    Def_BorderRoundHeight  :=  _prop_BorderRoundHeight;
// Over // ov
    Over_ColorOuter        :=  _prop_Color;
    Over_ColorFrom         :=  _prop_ovColorFrom;
    Over_ColorTo           :=  _prop_ovColorTo;
    Over_GradientStyle     :=  GStyle[_prop_ovGradientStyle];
    Over_ColorText         :=  _prop_ovColorText;
    Over_ColorShadow       :=  _prop_ovColorShadow;
    Over_ShadowOffset      :=  _prop_ovShadowOffset;
    Over_BorderWidth       :=  _prop_ovBorderWidth;
    Over_BorderColor       :=  _prop_ovBorderColor;
    Over_BorderRoundWidth  :=  _prop_ovBorderRoundWidth;
    Over_BorderRoundHeight :=  _prop_ovBorderRoundHeight;
// Down // ps
    Down_ColorOuter        :=  _prop_Color;
    Down_ColorFrom         :=  _prop_psColorFrom;
    Down_ColorTo           :=  _prop_psColorTo;
    Down_GradientStyle     :=  GStyle[_prop_psGradientStyle];
    Down_ColorText         :=  _prop_psColorText;
    Down_ColorShadow       :=  _prop_psColorShadow;
    Down_ShadowOffset      :=  _prop_psShadowOffset;
    Down_BorderWidth       :=  _prop_psBorderWidth;
    Down_BorderColor       :=  _prop_psBorderColor;
    Down_BorderRoundWidth  :=  _prop_psBorderRoundWidth;
    Down_BorderRoundHeight :=  _prop_psBorderRoundHeight;
// Dis // ds
    Dis_ColorOuter         :=  _prop_Color;
    Dis_ColorFrom          :=  _prop_dsColorFrom;
    Dis_ColorTo            :=  _prop_dsColorTo;
    Dis_GradientStyle      :=  GStyle[_prop_dsGradientStyle];
    Dis_ColorText          :=  _prop_dsColorText;
    Dis_ColorShadow        :=  _prop_dsColorShadow;
    Dis_ShadowOffset       :=  _prop_dsShadowOffset;
    Dis_BorderColor        :=  _prop_dsBorderColor;
    Dis_BorderWidth        :=  _prop_dsBorderWidth;
    Dis_BorderRoundWidth   :=  _prop_dsBorderRoundWidth;
    Dis_BorderRoundHeight  :=  _prop_dsBorderRoundHeight;
    
   end;
end;
// All
procedure GRush._work_doDrawFocusRect;       begin PGRushControl(Control).All_DrawFocusRect      := ReadBool(_Data); Control.Invalidate; end;
procedure GRush._work_doAntiAliasing;        begin PGRushControl(Control).All_AntiAliasing       := ReadBool(_Data); Control.Invalidate; end;
procedure GRush._work_dohAlignment;
begin
   _prop_hAlignment := ToInteger(_Data);
   PGRushControl(Control).All_TextHAlign := HAlign[_prop_hAlignment]; 
   Control.Invalidate;
end;
procedure GRush._work_dovAlignment;
begin 
   _prop_vAlignment := ToInteger(_Data);
   PGRushControl(Control).All_TextVAlign := VAlign[_prop_vAlignment];
   Control.Invalidate;
end;

procedure GRush._work_doLoadGVars;
begin
 // if _IsInteger(ForceGVar('grColor')^) then _work_doColor(_Data,ToInteger(ForceGVar('grColor')^));
  inherited;
  {$ifdef F_P}
  with PGRushControl(Control) do
  {$else}
  with PGRushControl(Control)^ do
  {$endif}
   begin
// All
  if _IsInteger(ForceGVar('grUpdateSpeed')^) then
    begin
     _prop_UpdateSpeed := ToInteger(ForceGVar('grUpdateSpeed')^);
     All_UpdateSpeed := Speed[_prop_UpdateSpeed];
    end;
  if _IsInteger(ForceGVar('grCheckMetric')^)         then All_CheckMetric        := ToInteger(ForceGVar('grCheckMetric')^);        
// Color // All
  if _IsInteger(ForceGVar('grColor')^)               then Def_ColorOuter         := ToInteger(ForceGVar('grColor')^);
  if _IsInteger(ForceGVar('grColor')^)               then Over_ColorOuter        := ToInteger(ForceGVar('grColor')^);
  if _IsInteger(ForceGVar('grColor')^)               then Down_ColorOuter        := ToInteger(ForceGVar('grColor')^);  
  if _IsInteger(ForceGVar('grColor')^)               then Dis_ColorOuter         := ToInteger(ForceGVar('grColor')^);
// Def //
  if _IsInteger(ForceGVar('grColorFrom')^)           then Def_ColorFrom          := ToInteger(ForceGVar('grColorFrom')^);  
  if _IsInteger(ForceGVar('grColorTo')^)             then Def_ColorTo            := ToInteger(ForceGVar('grColorTo')^);
  if _IsInteger(ForceGVar('grGradientStyle')^) then
    begin
     _prop_GradientStyle := ToInteger(ForceGVar('grGradientStyle')^);
     Def_GradientStyle := GStyle[_prop_GradientStyle];
    end;  
  if _IsInteger(ForceGVar('grColorText')^)           then Def_ColorText          := ToInteger(ForceGVar('grColorText')^);
  if _IsInteger(ForceGVar('grColorShadow')^)         then Def_ColorShadow        := ToInteger(ForceGVar('grColorShadow')^);  
  if _IsInteger(ForceGVar('grShadowOffset')^)        then Def_ShadowOffset       := ToInteger(ForceGVar('grShadowOffset')^);  
  if _IsInteger(ForceGVar('grBorderWidth')^)         then Def_BorderWidth        := ToInteger(ForceGVar('grBorderWidth')^);  
  if _IsInteger(ForceGVar('grBorderColor')^)         then Def_BorderColor        := ToInteger(ForceGVar('grBorderColor')^);
  if _IsInteger(ForceGVar('grBorderRoundWidth')^)    then Def_BorderRoundWidth   := ToInteger(ForceGVar('grBorderRoundWidth')^);  
  if _IsInteger(ForceGVar('grBorderRoundHeight')^)   then Def_BorderRoundHeight  := ToInteger(ForceGVar('grBorderRoundHeight')^); 
// Over // ov
  if _IsInteger(ForceGVar('grovColorFrom')^)         then Over_ColorFrom         := ToInteger(ForceGVar('grovColorFrom')^);  
  if _IsInteger(ForceGVar('grovColorTo')^)           then Over_ColorTo           := ToInteger(ForceGVar('grovColorTo')^);
  if _IsInteger(ForceGVar('grovGradientStyle')^) then
    begin
     _prop_GradientStyle := ToInteger(ForceGVar('grovGradientStyle')^);
     Over_GradientStyle := GStyle[_prop_GradientStyle];
    end;  
  if _IsInteger(ForceGVar('grovColorText')^)         then Over_ColorText         := ToInteger(ForceGVar('grovColorText')^);
  if _IsInteger(ForceGVar('grovColorShadow')^)       then Over_ColorShadow       := ToInteger(ForceGVar('grovColorShadow')^);  
  if _IsInteger(ForceGVar('grovShadowOffset')^)      then Over_ShadowOffset      := ToInteger(ForceGVar('grovShadowOffset')^);  
  if _IsInteger(ForceGVar('grovBorderWidth')^)       then Over_BorderWidth       := ToInteger(ForceGVar('grovBorderWidth')^);  
  if _IsInteger(ForceGVar('grovBorderColor')^)       then Over_BorderColor       := ToInteger(ForceGVar('grovBorderColor')^);
  if _IsInteger(ForceGVar('grovBorderRoundWidth')^)  then Over_BorderRoundWidth  := ToInteger(ForceGVar('grovBorderRoundWidth')^);  
  if _IsInteger(ForceGVar('grovBorderRoundHeight')^) then Over_BorderRoundHeight := ToInteger(ForceGVar('grovBorderRoundHeight')^);   
// Down // ps
  if _IsInteger(ForceGVar('grpsColorFrom')^)         then Down_ColorFrom         := ToInteger(ForceGVar('grovColorFrom')^);  
  if _IsInteger(ForceGVar('grpsColorTo')^)           then Down_ColorTo           := ToInteger(ForceGVar('grovColorTo')^);
  if _IsInteger(ForceGVar('grpsGradientStyle')^) then
    begin
     _prop_GradientStyle := ToInteger(ForceGVar('grpsGradientStyle')^);
     Down_GradientStyle := GStyle[_prop_GradientStyle];
    end;  
  if _IsInteger(ForceGVar('grpsColorText')^)         then Down_ColorText         := ToInteger(ForceGVar('grpsColorText')^);
  if _IsInteger(ForceGVar('grpsColorShadow')^)       then Down_ColorShadow       := ToInteger(ForceGVar('grpsColorShadow')^);  
  if _IsInteger(ForceGVar('grpsShadowOffset')^)      then Down_ShadowOffset      := ToInteger(ForceGVar('grpsShadowOffset')^);  
  if _IsInteger(ForceGVar('grpsBorderWidth')^)       then Down_BorderWidth       := ToInteger(ForceGVar('grpsBorderWidth')^);  
  if _IsInteger(ForceGVar('grpsBorderColor')^)       then Down_BorderColor       := ToInteger(ForceGVar('grpsBorderColor')^);
  if _IsInteger(ForceGVar('grpsBorderRoundWidth')^)  then Down_BorderRoundWidth  := ToInteger(ForceGVar('grpsBorderRoundWidth')^);  
  if _IsInteger(ForceGVar('grpsBorderRoundHeight')^) then Down_BorderRoundHeight := ToInteger(ForceGVar('grpsBorderRoundHeight')^); 
// Dis // ds
  if _IsInteger(ForceGVar('grdsColorFrom')^)         then Dis_ColorFrom          := ToInteger(ForceGVar('grdsColorFrom')^);  
  if _IsInteger(ForceGVar('grdsColorTo')^)           then Dis_ColorTo            := ToInteger(ForceGVar('grdsColorTo')^);
  if _IsInteger(ForceGVar('grdsGradientStyle')^) then
    begin
     _prop_GradientStyle := ToInteger(ForceGVar('grdsGradientStyle')^);
     Dis_GradientStyle := GStyle[_prop_GradientStyle];
    end;  
  if _IsInteger(ForceGVar('grdsColorText')^)         then Dis_ColorText          := ToInteger(ForceGVar('grdsColorText')^);
  if _IsInteger(ForceGVar('grdsColorShadow')^)       then Dis_ColorShadow        := ToInteger(ForceGVar('grdsColorShadow')^);  
  if _IsInteger(ForceGVar('grdsShadowOffset')^)      then Dis_ShadowOffset       := ToInteger(ForceGVar('grdsShadowOffset')^);  
  if _IsInteger(ForceGVar('grdsBorderWidth')^)       then Dis_BorderWidth        := ToInteger(ForceGVar('grdsBorderWidth')^);  
  if _IsInteger(ForceGVar('grdsBorderColor')^)       then Dis_BorderColor        := ToInteger(ForceGVar('grdsBorderColor')^);
  if _IsInteger(ForceGVar('grdsBorderRoundWidth')^)  then Dis_BorderRoundWidth   := ToInteger(ForceGVar('grdsBorderRoundWidth')^);  
  if _IsInteger(ForceGVar('grdsBorderRoundHeight')^) then Dis_BorderRoundHeight  := ToInteger(ForceGVar('grdsBorderRoundHeight')^);   
 end;
  Control.Invalidate;
end;

procedure GRush._work_doUpdateSpeed; 
begin 
   _prop_UpdateSpeed := ToInteger(_Data); 
   PGRushControl(Control).All_UpdateSpeed := Speed[_prop_UpdateSpeed];
   Control.Invalidate;
end;
procedure GRush._work_doCheckMetric;         begin PGRushControl(Control).All_CheckMetric        := ToInteger(_Data); Control.Invalidate; end;
procedure GRush._work_doColorCheck;          begin PGRushControl(Control).All_ColorCheck         := ToInteger(_Data); Control.Invalidate; end;
procedure GRush._work_doSpacing;             begin PGRushControl(Control).All_Spacing            := ToInteger(_Data); Control.Invalidate; end;
procedure GRush._work_doKind;                begin PGRushControl(Control).All_ProgressVertical   := ReadBool(_Data); Control.Invalidate; end;
procedure GRush._work_doRect;                begin PGRushControl(Control).All_DrawProgressRect   := ReadBool(_Data); Control.Invalidate; end;
procedure GRush._work_doDrawProgress;        begin PGRushControl(Control).All_DrawProgress       := ReadBool(_Data); Control.Invalidate; end;


// Color // All
procedure GRush._work_doColor;
begin
  inherited;
  {$ifdef F_P}
  with PGRushControl(Control) do
  {$else}
  with PGRushControl(Control)^ do
  {$endif}
   begin
    Def_ColorOuter  := ToInteger(_Data);
    Over_ColorOuter := ToInteger(_Data);
    Down_ColorOuter := ToInteger(_Data);
    Dis_ColorOuter  := ToInteger(_Data);
   end;
  Control.Invalidate;
end;
// Def //
procedure GRush._work_doColorFrom;           begin PGRushControl(Control).Def_ColorFrom          := ToInteger(_Data); Control.Invalidate; end;
procedure GRush._work_doColorTo;             begin PGRushControl(Control).Def_ColorTo            := ToInteger(_Data); Control.Invalidate; end;
procedure GRush._work_doGradientStyle;
begin
   _prop_GradientStyle := ToInteger(_Data);
   PGRushControl(Control).Def_GradientStyle := GStyle[_prop_GradientStyle];
   Control.Invalidate;
end;
procedure GRush._work_doColorText;           begin PGRushControl(Control).Def_ColorText          := ToInteger(_Data); Control.Invalidate; end;
procedure GRush._work_doColorShadow;         begin PGRushControl(Control).Def_ColorShadow        := ToInteger(_Data); Control.Invalidate; end;
procedure GRush._work_doShadowOffset;        begin PGRushControl(Control).Def_ShadowOffset       := ToInteger(_Data); Control.Invalidate; end;
procedure GRush._work_doBorderWidth;         begin PGRushControl(Control).Def_BorderWidth        := ToInteger(_Data); Control.Invalidate; end;
procedure GRush._work_doBorderColor;         begin PGRushControl(Control).Def_BorderColor        := ToInteger(_Data); Control.Invalidate; end;
procedure GRush._work_doBorderRoundWidth;    begin PGRushControl(Control).Def_BorderRoundWidth   := ToInteger(_Data); Control.Invalidate; end;
procedure GRush._work_doBorderRoundHeight;   begin PGRushControl(Control).Def_BorderRoundHeight  := ToInteger(_Data); Control.Invalidate; end;
// Over // ov
procedure GRush._work_doovColorFrom;         begin PGRushControl(Control).Over_ColorFrom         := ToInteger(_Data); Control.Invalidate; end;
procedure GRush._work_doovColorTo;           begin PGRushControl(Control).Over_ColorTo           := ToInteger(_Data); Control.Invalidate; end;
procedure GRush._work_doovGradientStyle;
begin
   _prop_ovGradientStyle := ToInteger(_Data);
   PGRushControl(Control).Over_GradientStyle := GStyle[_prop_ovGradientStyle];
   Control.Invalidate;
end;
procedure GRush._work_doovColorText;         begin PGRushControl(Control).Over_ColorText         := ToInteger(_Data); Control.Invalidate; end;
procedure GRush._work_doovColorShadow;       begin PGRushControl(Control).Over_ColorShadow       := ToInteger(_Data); Control.Invalidate; end;
procedure GRush._work_doovShadowOffset;      begin PGRushControl(Control).Over_ShadowOffset      := ToInteger(_Data); Control.Invalidate; end;
procedure GRush._work_doovBorderWidth;       begin PGRushControl(Control).Over_BorderWidth       := ToInteger(_Data); Control.Invalidate; end;
procedure GRush._work_doovBorderColor;       begin PGRushControl(Control).Over_BorderColor       := ToInteger(_Data); Control.Invalidate; end;
procedure GRush._work_doovBorderRoundWidth;  begin PGRushControl(Control).Over_BorderRoundWidth  := ToInteger(_Data); Control.Invalidate; end;
procedure GRush._work_doovBorderRoundHeight; begin PGRushControl(Control).Over_BorderRoundHeight := ToInteger(_Data); Control.Invalidate; end;
// Down // ps
procedure GRush._work_dopsColorFrom;         begin PGRushControl(Control).Down_ColorFrom         := ToInteger(_Data); Control.Invalidate; end;
procedure GRush._work_dopsColorTo;           begin PGRushControl(Control).Down_ColorTo           := ToInteger(_Data); Control.Invalidate; end;
procedure GRush._work_dopsGradientStyle;
begin
   _prop_psGradientStyle := ToInteger(_Data);
   PGRushControl(Control).Down_GradientStyle := GStyle[_prop_psGradientStyle];
   Control.Invalidate;
end;
procedure GRush._work_dopsColorText;         begin PGRushControl(Control).Down_ColorText         := ToInteger(_Data); Control.Invalidate; end;
procedure GRush._work_dopsColorShadow;       begin PGRushControl(Control).Down_ColorShadow       := ToInteger(_Data); Control.Invalidate; end;
procedure GRush._work_dopsShadowOffset;      begin PGRushControl(Control).Down_ShadowOffset      := ToInteger(_Data); Control.Invalidate; end;
procedure GRush._work_dopsBorderWidth;       begin PGRushControl(Control).Down_BorderWidth       := ToInteger(_Data); Control.Invalidate; end;
procedure GRush._work_dopsBorderColor;       begin PGRushControl(Control).Down_BorderColor       := ToInteger(_Data); Control.Invalidate; end;
procedure GRush._work_dopsBorderRoundWidth;  begin PGRushControl(Control).Down_BorderRoundWidth  := ToInteger(_Data); Control.Invalidate; end;
procedure GRush._work_dopsBorderRoundHeight; begin PGRushControl(Control).Down_BorderRoundHeight := ToInteger(_Data); Control.Invalidate; end;
// Dis // ds
procedure GRush._work_dodsColorFrom;         begin PGRushControl(Control).Dis_ColorFrom         := ToInteger(_Data); Control.Invalidate; end;
procedure GRush._work_dodsColorTo;           begin PGRushControl(Control).Dis_ColorTo           := ToInteger(_Data); Control.Invalidate; end;
procedure GRush._work_dodsGradientStyle;
begin
   _prop_dsGradientStyle := ToInteger(_Data);
   PGRushControl(Control).Dis_GradientStyle := GStyle[_prop_dsGradientStyle];
   Control.Invalidate;
end;
procedure GRush._work_dodsColorText;         begin PGRushControl(Control).Dis_ColorText         := ToInteger(_Data); Control.Invalidate; end;
procedure GRush._work_dodsColorShadow;       begin PGRushControl(Control).Dis_ColorShadow       := ToInteger(_Data); Control.Invalidate; end;
procedure GRush._work_dodsShadowOffset;      begin PGRushControl(Control).Dis_ShadowOffset      := ToInteger(_Data); Control.Invalidate; end;
procedure GRush._work_dodsBorderWidth;       begin PGRushControl(Control).Dis_BorderWidth       := ToInteger(_Data); Control.Invalidate; end;
procedure GRush._work_dodsBorderColor;       begin PGRushControl(Control).Dis_BorderColor       := ToInteger(_Data); Control.Invalidate; end;
procedure GRush._work_dodsBorderRoundWidth;  begin PGRushControl(Control).Dis_BorderRoundWidth  := ToInteger(_Data); Control.Invalidate; end;
procedure GRush._work_dodsBorderRoundHeight; begin PGRushControl(Control).Dis_BorderRoundHeight := ToInteger(_Data); Control.Invalidate; end;

procedure GRush._work_doCaption;
begin
   Control.Caption := ReadString(_Data,Null,'');
end;

procedure GRush.SetCaption;
begin
  Control.Caption := Value;
end;

{procedure GRush.SetPicture;
begin
  if Value = 0 then exit;
  All_GlyphBitmap:= NewBitmap(0, 0);
//    Bmp.Handle := Value; 
end;}

end.
