unit higrCheckBox;

interface

{$I share.inc}

uses Kol,Share,KOLGRushControls,grShare;

type
 THIgrCheckBox = class(GRush)
   private
     procedure _OnClick(Obj:PObj);
     procedure SetChecked(Value:byte);
   public
    _event_onCheck:THI_Event;
    _event_onClick:THI_Event;
    constructor Create(Parent:PControl);   
    procedure _work_doCheck(var _Data:TData; Index:word);
    procedure _var_Checked(var _Data:TData; Index:word);
    property _prop_Checked:byte write SetChecked;
 end;

implementation

constructor THIgrCheckBox.Create;
begin
   inherited Create(Parent);
   Control := NewGRushCheckBox(Parent,'grCheckBox');
   Control.OnClick := _OnClick;
   {$ifdef F_P}
   _prop_Ctl3D := 0;
   {$else}
   _prop_Ctl3D := 1;
   {$endif}
end;

procedure THIgrCheckBox._work_doCheck;
begin
   Control.Checked := ReadBool(_Data);
   _hi_onEvent(_event_onCheck,byte(Control.Checked ));
end;

procedure THIgrCheckBox._var_Checked;
begin
   dtInteger(_Data,integer(Control.Checked));
end;

procedure THIgrCheckBox.SetChecked;
begin
   Control.Checked := Value = 0;
end;

procedure THIgrCheckBox._OnClick;
begin
   _hi_onEvent(_event_onCheck,byte(Control.Checked ));
   _hi_onEvent(_event_onClick,byte(Control.Checked ));
end;

end.
