unit higrRadioButton;

interface

{$I share.inc}

uses Windows,Kol,Share,Messages,KOLGRushControls,grShare;

type
 THIgrRadioButton = class(GRush)
   private
     procedure _OnClick(Obj:PObj);
  {   procedure _OnMouseEnter(Sender:PObj);
     procedure _OnMouseLeave(Sender:PObj);}
     procedure SetSelected(Value:byte);
   public
    _event_onSelect:THI_Event;
    _event_onClick:THI_Event;
    _event_onMouseEnter:THI_Event;
    _event_onMouseLeave:THI_Event;

    _prop_Clicked:boolean;

    constructor Create(Parent:PControl);   
    procedure _work_doSelect(var _Data:TData; Index:word);
    procedure _var_Selected(var _Data:TData; Index:word);
    property _prop_Selected:byte write SetSelected;
 end;

implementation

constructor THIgrRadioButton.Create;
begin
   inherited Create(Parent);
   Control := NewGRushRadioBox(Parent,'grRadioButton');
   Control.OnClick := _OnClick;
  { Control.OnMouseEnter  := _onMouseEnter;
   Control.OnMouseLeave  := _onMouseLeave; }
   {$ifdef F_P}
   _prop_Ctl3D := 0;
   {$else}
   _prop_Ctl3D := 1;
   {$endif}
end;

procedure THIgrRadioButton._work_doSelect;
begin
   if _prop_Clicked then Control.Checked := ReadBool(_Data)
                    else SendMessage(Control.Handle,BM_CLICK,0,0);
      _hi_onEvent(_event_onSelect,byte(Control.Checked ));
end;

procedure THIgrRadioButton._var_Selected;
begin
   dtInteger(_Data,integer(Control.Checked));
end;

procedure THIgrRadioButton.SetSelected;
begin
  Control.Checked := value = 0;
end;

procedure THIgrRadioButton._OnClick;
begin
  _hi_onEvent(_event_onSelect,byte(Control.Checked ));
  _hi_onEvent(_event_onClick,byte(Control.Checked ));
end;

{procedure THIgrRadioButton._OnMouseEnter;
begin
   _hi_OnEvent(_event_onMouseEnter);
end;

procedure THIgrRadioButton._OnMouseLeave;
begin
   _hi_OnEvent(_event_onMouseLeave);
end;}

end.
